/************************************************************************************/
/*  Program name CAPFNDIMP_REQ_SET_PGRM.sql                                         */
/*  Creater:  Chan Billy Ka Keung (PCCW - UniHub)                                   */
/*************   History   *************************                                */
/* 01 FEB, 2006   CHAN Billy Ka Keung         First created                         */
/************************************************************************************/

SET SERVEROUTPUT ON SIZE 1000000;

DECLARE

	lv_PrOG_ID		VARCHAR2(100) 	:=	'CAPFNDIMP_REQ_SET_PGRM';

	lv_Scc_Count	NUMBER			:=	0;
	lv_Err_Count	NUMBER			:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	CURSOR Cur_F IS
	SELECT
		*
	FROM
		CRST_FND_REQ_SET_PGRM;

	lv_Next_Seq_ID	NUMBER;

BEGIN

	FOR C1 IN Cur_F LOOP
		BEGIN

			SELECT	FND_REQUEST_SET_PROGRAMS_S.NextVal
			INTO	lv_Next_Seq_ID
			FROM	DUAL;

			INSERT INTO CRST_FND_REQ_SET_PGRM_MAP
			VALUES
			(
				C1.SET_APPLICATION_ID,
				C1.REQUEST_SET_ID,
				C1.REQUEST_SET_STAGE_ID,
				C1.REQUEST_SET_PROGRAM_ID,
				C1.SEQ,
				C1.SET_APPLICATION_ID,
				CAPBRIMP_MAPPING.GetRequestSetIDMapping(C1.REQUEST_SET_ID),				--REQUEST_SET_ID,
				CAPBRIMP_MAPPING.GetRequestSetStageIDMapping(C1.REQUEST_SET_STAGE_ID),	--REQUEST_SET_STAGE_ID,
				lv_Next_Seq_ID,
				C1.SEQ
			);

			INSERT INTO FND_REQUEST_SET_PROGRAMS
			VALUES
			(
				C1.SET_APPLICATION_ID,
				CAPBRIMP_MAPPING.GetRequestSetIDMapping(C1.REQUEST_SET_ID),				--REQUEST_SET_ID,
				CAPBRIMP_MAPPING.GetRequestSetStageIDMapping(C1.REQUEST_SET_STAGE_ID),	--REQUEST_SET_STAGE_ID,
				lv_Next_Seq_ID,
				C1.SEQ,
				C1.LAST_UPDATE_DATE,
				CAPBRIMP_COMMON.GetUser(C1.LAST_UPDATED_BY_NAME),						--LAST_UPDATED_BY,
				C1.CREATION_DATE,
				CAPBRIMP_COMMON.GetUser(C1.CREATED_BY_NAME),							--CREATED_BY,
				C1.LAST_UPDATE_LOGIN,
				C1.PROGRAM_APPLICATION_ID,
				CAPBRIMP_COMMON.GetFNDConcPrgID(C1.CONCURRENT_PROGRAM_ID_D),			--CONCURRENT_PROGRAM_ID,
				C1.NLS_LANGUAGE,
				C1.NLS_TERRITORY,
				C1.CRITICAL,
				C1.NUMBER_OF_COPIES,
				C1.PRINTER,
				C1.PRINT_STYLE,
				C1.SAVE_OUTPUT_FLAG
			);
		EXCEPTION
			WHEN OTHERS THEN
				DBMS_OUTPUT.Put_Line(SQLERRM);
				lv_Err_Count	:=	lv_Err_Count + 1;
		END;
		lv_Scc_Count		:= lv_Scc_Count + 1;
	END LOOP;

	IF lv_Err_Count	>	0	THEN
		ROLLBACK;
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count - lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/
